import 'dart:async';

import 'package:flutter/material.dart';
import 'package:flutter_boost/flutter_boost.dart';
import 'package:flutter_common/Annotations/anno/RouterCenter.dart';
import 'package:flutter_common/commonModel/util/WindowUtil.dart';
import 'package:gm_flutter/commonModel/base/BaseComponent.dart';

import 'DemoPage.dart';
import 'DemoPage1.dart';
import 'commonModel/base/BaseUtil.dart';
import 'commonModel/nav/NavigationService.dart';

NavigationService navigationService;

void main() {
  navigationService = NavigationService();
  WidgetsFlutterBinding.ensureInitialized();
  FlutterError.onError = (FlutterErrorDetails details) async {
    if (isDebug) {
      FlutterError.dumpErrorToConsole(details);
      Zone.root.handleUncaughtError(details.exception, details.stack);
      Zone.current.handleUncaughtError(details.exception, details.stack);
    } else {
      Zone.current.handleUncaughtError(details.exception, details.stack);
    }
  };
  runZonedGuarded(() {
    WidgetsFlutterBinding.ensureInitialized();

    runApp(
      MyAppWidget(),
    );
  }, (Object error, StackTrace stack) {
    //TODO
    print("lsy EEEEEE ${error.toString()}   ${stack.toString()}");
  });
}

@RouterCenter()
class MyAppWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return MyApp();
  }
}

class MyApp extends State<MyAppWidget> {
  @override
  void initState() {
    super.initState();
    FlutterBoost.singleton.registerPageBuilders({
      'demoPage': (pageName, params, _) {
        return DemoPage();
      },
      'demoPage1': (pageName, params, _) {
        return DemoPage1();
      },
    });
//    FlutterBoost.singleton.addBoostContainerLifeCycleObserver((state, settings) {
//    });
//    FlutterBoost.singleton.addBoostNavigatorObserver(TestBoostNavigatorObserver());
  }

  @override
  Widget build(BuildContext context) {
    WindowUtil.setBarStatus(true);
    return MaterialApp(
        theme: ThemeData(),
        builder: FlutterBoost.init(postPush: _onRoutePushed),
//        home: isDebug
//            ? Container(
//                color: Colors.red,
//              )
//            : Container(
//                color: Colors.white,
//                child: Center(
//                  child: loadingItem(),
//                ),
//              )
    );
  }

  void _onRoutePushed(
    String pageName,
    String uniqueId,
    Map<String, dynamic> params,
    Route<dynamic> route,
    Future<dynamic> _,
  ) {}
}
